importScripts(".precache-manifest.89e069506739a86386d448aaa8c4eff0.js");

importScripts('/third_party/workbox-v4.3.1/workbox-sw.js');

workbox.setConfig({
  modulePathPrefix: '/third_party/workbox-v4.3.1',
  debug: true
});

workbox.core.skipWaiting();
workbox.core.clientsClaim();
workbox.core.setCacheNameDetails({
  prefix: 'pwa_quiz',
  suffix: 'poc_v1',
  precache: "precache",
  runtime: "runtime-cache"
});

workbox.precaching.precacheAndRoute(self.__precacheManifest || [])

workbox.navigationPreload.enable();
workbox.routing.registerNavigationRoute(workbox.precaching.getCacheKeyForURL('/index.html'), {
  blacklist: [
    new RegExp('^/api/'), // Exclude URLs starting with /api/, as they're API calls (not navigation)
    new RegExp('/[^/]+\\.[^/]+$'), // Exclude URLs containing a dot, as they're likely a resource in public/ and not a SPA route
  ],
});

const bgSyncPlugin = new workbox.backgroundSync.Plugin('quizResults', {
  maxRetentionTime: 24 * 60
});

workbox.routing.registerRoute(
  /\.(?:js|svg|png|css|html)$/,
  new workbox.strategies.CacheFirst({
    cacheName: 'pwa_quiz-precache-poc_v1',
    plugins: [
      new workbox.cacheableResponse.Plugin({statuses: [304]}),
      new workbox.rangeRequests.Plugin(),
    ],
  }),
);

workbox.routing.registerRoute(
  '/api/category',
  workbox.strategies.staleWhileRevalidate(),
  'GET'
)

workbox.routing.registerRoute(
  '/api/results',
  workbox.strategies.networkFirst({
    plugins: [bgSyncPlugin]
  }),
  'POST'
)

